
#include "stdafx.h"
#include "resource.h"
#include "hello.h"

#include <iostream.h>	////-
#include <fstream.h>	////-
#include "astar.h"	////-

// theApp:
// Just creating this application object runs the whole application.
CTheApp NEAR theApp;

///////////////////////////////////////////////////////////////////////////////
// CTheApp

// InitInstance:
BOOL CTheApp::InitInstance()
{
	TRACE0("CTheApp::InitInstance\n");

	Enable3dControls(); // use 3d controls in dialogs

	m_pMainWnd = new CMainWnd;
	m_pMainWnd->ShowWindow(m_nCmdShow);
	m_pMainWnd->UpdateWindow();

	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
// CMainWnd 

// constructor:
CMainWnd::CMainWnd()
{
	LoadFrame(IDR_MAINFRAME);
}

CMainWnd::~CMainWnd()
{
}

// CMainWnd message map:
// Associate messages with member functions.
BEGIN_MESSAGE_MAP( CMainWnd, CFrameWnd )
	//{{AFX_MSG_MAP( CMainWnd )
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_COMMAND(ID_APP_ABOUT, OnAbout)
	//mouse
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

int CMainWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	//get map data from file	////-read map file
	ifstream in("map1.txt");
	if (!in)
		return CFrameWnd::OnCreate(lpCreateStruct);
	char ch;
	int i = 0;
	while((ch = in.get())>0 && i<MAPWIDTH*MAPHEIGHT)
	{
		if(ch<=57 && ch>=48)
		{
			MapData[i] = (int)ch-48;
			i++;
		}
	}
	in.close();

	m_StartIsSet = FALSE;	////-
	Astar = new AStar(MapData, 1);	////-

	return CFrameWnd::OnCreate(lpCreateStruct);
}

void CMainWnd::OnSize(UINT nType, int cx, int cy)
{
	//GetClientRect(&m_ClientRect);

	CFrameWnd::OnSize(nType, cx, cy);
}

// OnPaint:
void CMainWnd::OnPaint()
{
	DrawBitmap(this,MapData,MAPWIDTH,MAPHEIGHT,TILESIZE);
}

// OnAbout:
void CMainWnd::OnAbout()
{
	CDialog about(IDD_ABOUTBOX);
	about.DoModal();
}

// OnEraseBkgnd:
BOOL CMainWnd::OnEraseBkgnd(CDC* pDC)
{
/*
	if (m_bUseClientRGB)
	{
		//We're explicitly painting the area, so we don't want to call
		//the inherited method...
		SetClientColorRGB(m_crClient);
		return TRUE;
	}
*/
	//Otherwise call the inherited method
	return CFrameWnd::OnEraseBkgnd(pDC);
}

/////////////////////////////////////////////////////////////////////////////